#!/usr/bin/perl

# for CVS
# $Id: TANet-10min.pl,v 1.2 2005/03/28 07:48:51 jal Exp $

##############################################################################
#
# Modify the following to meet your configuration.
#
# jal.050328: QyqέpA mrtg eϥ
#
# $dir is where you put your program and config files
# $rawdir is where the raw log files kept
#    

$dir       = "/home/analyzer";
$rawdir    = "/home/tanet";
$tmpdir    = "$dir/tmp";
$flowprint = "/usr/local/bin/flow-print";

$protfile = "$dir/protocols";
$servfile = "$dir/services-10min";
$intranet = "$dir/intranet";

##############################################################################
#
# Do not modify the following code!
#    

require "$dir/TANet-netflow.pl";
&init_prot( $protfile );
&init_serv( $servfile );
&init_InNet( $intranet );

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time-600);
$mon++;
$year+=1900;
$min -= ($min % 10); #hӦ

#$nowtime = (time+60*60*8)%86400;
#$suffix = ($nowtime-(86400/144))/(86400/144);


$mmm = sprintf ("ft-v05.%04d-%02d-%02d.%02d%02d", $year, $mon, $mday, $hour, $min);
$dir = sprintf ("%04d/%04d-%02d/%04d-%02d-%02d", $year, $year, $mon, $year, $mon, $mday);

opendir DIRREF, "$rawdir/$dir" || die $!;
@flowfiles = grep /^$mmm/, readdir DIRREF;

#$file=grep /^$mmm;

#printf $file;
closedir DIRREF;

#$file = sprintf ("rawflow.%02d-%02d-%02d.%d",  $mon, $mday, $year, $suffix);

foreach (@flowfiles) {
  open FLOWDATA, "$flowprint -f0 < $rawdir/$dir/$_ |" || die $!;
     while (<FLOWDATA>) {
     chomp;
#
# $sif, $dif: input/output interface  (get it via router by snmpwalk)
# $src, $dst: source/destination ip
# $proto    : protocol (refer to /etc/protocols, ICMP = 1, TCP = 6, UDP = 17)
# $sp,  $dp : source/destination port (transport layer protocol, /etc/services)
# $pkts     : total packets in this flow
# $size     : total octects in this flow
#

#
# The reason we use substr and index instead of split is due to the
# consideration of efficiency.
#
#

 ($sif, $src, $dif, $dst, $proto, $sp, $dp, $pkts, $size) = split /\s+/ , $_;

 $proto=hex($proto);
 $sp=hex($sp);
 $dp=hex($dp);

#   $size /= 1024;

#   $pkts /= 1000;
#   $size /= (1024*1024);

#   printf "$sif, $src, $dif, $dst, $proto, $sp, $dp, $pkts, $size\n";
   &chkInOutNetwork;
  }
}

&daily_summary;
&netflow_10min_output;

sub update_rec {
   my($net, $io) = @_;
   
   if ($proto == 6 || $proto == 17) {
      if ($service{"$sp"}) {
         $port = $sp;
      }
      elsif ($service{"$dp"}) {
         $port = $dp;
      }
      else {
         $port = "others";
      }
   }
   elsif ($proto == 1) {
      $port = "icmp";
   }
   
   ${$net.$io.$port.FLOW} ++;
   ${$net.$io.$port.PKTS} += $pkts;
   ${$net.$io.$port.SIZE} += $size;
}

sub daily_summary {
   my($net) = "TANet";
   my($io, $port);
   foreach $io ("IN", "OUT") {
      foreach $port (keys(%service)) {
         if ($service{$port} ne "total") {
            foreach $fps ("FLOW", "PKTS", "SIZE") {
               ${$net.$io.total.$fps} += ${$net.$io.$port.$fps};
            }
         } # if
      } # port
   } # io
}

sub netflow_10min_output {
   my($net) = "TANet";
   open FILE, "> $tmpdir/mrtg" or die $!;
      foreach $port (keys(%service)) {
         if ( ${$net.IN.$port.FLOW} || ${$net.OUT.$port.FLOW} ) {
            foreach $fps ("FLOW", "PKTS", "SIZE") {
               printf FILE ("%s %3s %8s %6s %8u %8u\n",
                  $net, $io, $service{$port}, $fps,
                  ${$net.IN.$port.$fps},
                  ${$net.OUT.$port.$fps});
            }
         } # if
      } # port
   close FILE;
}
